#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QtNetwork/QFtp>
#include <QFile>
#include <QtNetwork/QHttp>
#include "progressdialog.h"
#include "welcome.h"
#include <QSystemTrayIcon>
#include <QAction>
#include <QStringList>

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void FTP_Connect();
    void FTP_Disconnect();
    int DownloadFile(QString src, QString dest);
    int FTP_Command;
    void SaveSettings();
    void LoadSettings();
    int UploadFile(QString src, QString dest);
    void startBackup();
    void RewriteTS();
    void reloadFiles();
    void ShowError(QString title, QString text);
    void NextUpdateFile();

    QString Timestamp;
    bool prg_visible;
    bool prg_autohide;
    bool isLoaded;
    bool ShowErrs;
    int cUpdate;
    QStringList upd;

public slots:
    void AboutQt();
    void TestConnection();
    void cmdFinished(int,bool errorl);
    void BackupNow();
    void AddFile();
    void RemoveFile();
    void CheckForUpdates();
    void ResetSettings();
    void updateDataTransferProgress(qint64,qint64);
    void CheckLocalChange(int state);
    void httpFinished();
    void iconActivated(QSystemTrayIcon::ActivationReason);
    void timerovf();
    void EnabledChanged();
    void importFiles();
    void exportFiles();
    void AboutIcons();
    void whatsNew();

private:
    Ui::MainWindow *ui;
    QFtp *ftp;
    QFile *file;
    QHttp *http;
    int fid;
    void NextFile();
    progressDialog *prgdlg;
    welcome *welcomescreen;
    QSystemTrayIcon *trayIcon;
    QMenu *trayIconMenu;
    QAction *restoreAction;
    QAction *quitAction;
    QTimer *tim;
};

#endif // MAINWINDOW_H
